/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Monitor;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.TraverseListener;
import org.eclipse.swt.events.TraverseEvent;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Composite;


public class Entrada extends Dialog {

	protected Shell shellEntrada;
	String campo=null;
	String texto=null;
	boolean clave=false;
	private Text textCampo;
	private String resultado=null;
	private Button btnAceptar;
	private Button btnCancelar;
	public Entrada(Shell parent,String campo,String texto,boolean clave) {
		super(parent, SWT.TITLE | SWT.BORDER | SWT.APPLICATION_MODAL);
		setText("Dialogo de entrada");
		this.campo=campo;
		this.texto=texto;
		this.clave=clave;
	}
	public String open() {
		createContents();
		Display display = getParent().getDisplay();
		Monitor primary = display.getPrimaryMonitor ();
		Rectangle bounds = primary.getBounds ();
		Rectangle rect = shellEntrada.getBounds ();
		int x = bounds.x + (bounds.width - rect.width) / 2;
		int y = bounds.y + (bounds.height - rect.height) / 2;
		shellEntrada.setLocation (x, y);
		shellEntrada.open();
		shellEntrada.layout();
		this.textCampo.setFocus();
		while (!shellEntrada.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
		return resultado;
	}
	private void createContents() {
		shellEntrada = new Shell(getParent(), SWT.BORDER | SWT.RESIZE | SWT.TITLE | SWT.APPLICATION_MODAL);
		shellEntrada.setSize(450, 300);
		shellEntrada.setLayout(new GridLayout(1, false));
		shellEntrada.setText(PCuaderno.MiPCuaderno.titulo+" - "+this.campo);
		Text textMensaje = new Text(shellEntrada, SWT.BORDER | SWT.READ_ONLY | SWT.WRAP | SWT.V_SCROLL | SWT.CENTER | SWT.MULTI);
		textMensaje.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		textMensaje.setText(this.texto);
		textMensaje.pack();
		Composite cmpCampo = new Composite(shellEntrada, SWT.NONE);
		cmpCampo.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, false, false, 1, 1));
		cmpCampo.setLayout(new GridLayout(2, false));
		Label lblCampo = new Label(cmpCampo, SWT.NONE);
		lblCampo.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblCampo.setText(this.campo+": ");
		textCampo = new Text(cmpCampo, ((this.clave)?SWT.BORDER | SWT.PASSWORD:SWT.BORDER));
		textCampo.addTraverseListener(new TraverseListener() {
			public void keyTraversed(TraverseEvent arg0) {
				//System.out.println("tecla "+arg0.keyCode+" == "+SWT.CR);
				if (arg0.keyCode==SWT.CR){
					resultado=textCampo.getText();
					textCampo.setEnabled(false);
					btnCancelar.setEnabled(false);
					btnAceptar.setEnabled(false);
					shellEntrada.dispose();				
				}
			}
		});
		GridData gd_textCampo = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_textCampo.widthHint = 150;
		textCampo.setLayoutData(gd_textCampo);
		textCampo.setText("");
		Composite cmpBotones = new Composite(shellEntrada, SWT.NONE);
		cmpBotones.setLayout(new GridLayout(2, false));
		cmpBotones.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		btnCancelar = new Button(cmpBotones, SWT.NONE);
		btnCancelar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				textCampo.setEnabled(false);
				btnCancelar.setEnabled(false);
				btnAceptar.setEnabled(false);
				shellEntrada.dispose();
			}
		});
		btnCancelar.setText("Cancelar");
		btnAceptar = new Button(cmpBotones, SWT.NONE);
		btnAceptar.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		btnAceptar.setText("Aceptar");
		btnAceptar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				resultado=textCampo.getText();
				textCampo.setEnabled(false);
				btnCancelar.setEnabled(false);
				btnAceptar.setEnabled(false);
				shellEntrada.dispose();
			}
		});
	}
}