/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Vector;

import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Combo;

public class Matricula extends Composite {
	private Text txtEnsenanzaRef;public Text getTxtEnsenanzaRef(){return txtEnsenanzaRef;}
	private Text txtEnsenanza;public Text getTxtEnsenanza(){return txtEnsenanza;}
	private Text txtTituloRef;public Text getTxtTituloRef(){return txtTituloRef;}
	private Text txtTitulo;public Text getTxtTitulo(){return txtTitulo;}
	private Text txtNivelRef;public Text getTxtNivelRef(){return txtNivelRef;}
	private Text txtClaseRef;public Text getTxtClaseRef(){return txtClaseRef;}
	private Text txtMateriaRef;public Text getTxtMateriaRef(){return txtMateriaRef;}
	private Text txtMateria;public Text getTxtMateria(){return txtMateria;}
	private Text txtEstudianteNombre;public Text getTxtEstudianteNombre(){return txtEstudianteNombre;}
	private Text txtEstudianteApellidos;public Text getTxtEstudianteApellidos(){return txtEstudianteApellidos;}
	private Text txtEstudianteDatos;public Text getTxtEstudianteDatos(){return txtEstudianteDatos;}
	private Button btnEnsenanzaNuevo;
	private Button btnEnsenanzaBorrar;
	private Button btnTituloNuevo;
	private Button btnTituloBorrar;
	private Button btnNivelNuevo;
	private Button btnNivelBorrar;
	private Button btnClaseNueva;
	private Button btnClaseBorrar;
	private Button btnMateriaNueva;
	private Button btnMateriaBorrar;
	private Button btnEstudianteNuevo;
	private Button btnEstudianteBorrar;
	private Button btnMatriculadoQuitar;
	private Button btnEstudianteMatricular;
	private Button btnImportarEstudiantes;
	private ListConId listConIdEnsenanzas;
	private ListConId listConIdTitulos;
	private ListConId listConIdNiveles;
	private ListConId listConIdClases;
	private ListConId listConIdEstudiantes;
	private ListConId listConIdMaterias;
	private ListConId listConIdMatriculados;
	private Group grpEstudiantes;
	private Group grpMatriculados;
	private ComboConId comboConIdClaseTutor;
	private final static String TituloEstudiantes="Estudiantes de la Clase:";
	private final static String TituloMatriculados="Matriculados Materia:";
	private Composite composite;
	public Matricula(Composite parent, int style) {
		super(parent, style);
		initialize();
	}
	public void actualizar() {
		actualizarEnsenanzas(MateriaClase.getIdEnsenanzaDeTrabajo());
		actualizarTitulos(MateriaClase.getIdTituloDeTrabajo());
		actualizarNiveles(MateriaClase.getIdNivelDeTrabajo());
		actualizarMaterias(MateriaClase.getIdMateriaDeTrabajo());
		actualizarClases(MateriaClase.getIdClaseDeTrabajo());
	}
	private void initialize() {
		GridLayout gridLayoutMatricula = new GridLayout();
		gridLayoutMatricula.numColumns = 4;
		gridLayoutMatricula.horizontalSpacing = 2;
		gridLayoutMatricula.verticalSpacing = 2;
		gridLayoutMatricula.marginWidth = 2;
		gridLayoutMatricula.marginHeight = 2;
		GridData gridDataMatricula = new GridData();
		gridDataMatricula.grabExcessHorizontalSpace = true;
		gridDataMatricula.grabExcessVerticalSpace = true;
		gridDataMatricula.horizontalAlignment = GridData.FILL;
		gridDataMatricula.verticalAlignment = GridData.FILL;
		this.setLayoutData(gridDataMatricula);
		this.setLayout(gridLayoutMatricula);
		this.setSize(new Point(685, 340));
		
		Group grpEnsenanzas = new Group(this, SWT.NONE);
		grpEnsenanzas.setText("Enseñanzas:");
		GridLayout gl_grpEnsenanzas = new GridLayout(2, false);
		gl_grpEnsenanzas.verticalSpacing = 2;
		gl_grpEnsenanzas.marginWidth = 2;
		gl_grpEnsenanzas.marginHeight = 2;
		gl_grpEnsenanzas.horizontalSpacing = 2;
		grpEnsenanzas.setLayout(gl_grpEnsenanzas);
		GridData gd_grpEnsenanzas = new GridData(SWT.FILL, SWT.FILL, true, false, 1, 2);
		gd_grpEnsenanzas.heightHint = 125;
		grpEnsenanzas.setLayoutData(gd_grpEnsenanzas);
		
		List listEnsenanzas = new List(grpEnsenanzas, SWT.BORDER | SWT.V_SCROLL);
		listEnsenanzas.setToolTipText("Lista de las enseñanzas tratadas por el programa. Por ejemplo:" +
				" ESO, Bachillerato, CFGM, CFGS.");
		listEnsenanzas.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listEnsenanzas "+listConIdEnsenanzas.idSeleccionado());
				actualizarDatosEnsenanza();
			}
		});
		GridData gd_listEnsenanzas = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 3);
		gd_listEnsenanzas.widthHint = 60;
		gd_listEnsenanzas.heightHint = 55;
		listEnsenanzas.setLayoutData(gd_listEnsenanzas);
		listConIdEnsenanzas = new ListConId(listEnsenanzas);
		
		Label lblEnsenanzaRef = new Label(grpEnsenanzas, SWT.NONE);
		lblEnsenanzaRef.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblEnsenanzaRef.setText("Ref.:");
		
		txtEnsenanzaRef = new Text(grpEnsenanzas, SWT.BORDER);
		txtEnsenanzaRef.setToolTipText("Referencia corta de la enseñanza seleccionada. Por ejemplo: Bach.");
		txtEnsenanzaRef.setText("XXXXX");
		GridData gd_textEnsenanzaRef = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_textEnsenanzaRef.widthHint = 55;
		txtEnsenanzaRef.setLayoutData(gd_textEnsenanzaRef);
		TextoDemorado.add(txtEnsenanzaRef,false,5,null,null,false,listConIdEnsenanzas,null);
		
		Composite compositeEnsenanzasNuevoBorrar = new Composite(grpEnsenanzas, SWT.NONE);
		compositeEnsenanzasNuevoBorrar.setLayoutData(new GridData(SWT.LEFT, SWT.BOTTOM, false, false, 1, 1));
		GridLayout gl_compositeEnsenanzasNuevoBorrar = new GridLayout(1, false);
		gl_compositeEnsenanzasNuevoBorrar.verticalSpacing = 2;
		gl_compositeEnsenanzasNuevoBorrar.marginWidth = 2;
		gl_compositeEnsenanzasNuevoBorrar.marginHeight = 2;
		gl_compositeEnsenanzasNuevoBorrar.horizontalSpacing = 2;
		compositeEnsenanzasNuevoBorrar.setLayout(gl_compositeEnsenanzasNuevoBorrar);
		
		btnEnsenanzaNuevo = new Button(compositeEnsenanzasNuevoBorrar, SWT.NONE);
		btnEnsenanzaNuevo.setToolTipText("Para crear una nueva enseñanza. Por ejemplo: CFGS.");
		btnEnsenanzaNuevo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnEnsenanzaNuevo");
				String id = BBDD.insertarEnsenanza("Nueva", "");
				actualizarEnsenanzas(id);
				txtEnsenanzaRef.setFocus();
				txtEnsenanzaRef.selectAll();
			}
		});
		btnEnsenanzaNuevo.setText("Nueva");
		
		btnEnsenanzaBorrar = new Button(compositeEnsenanzasNuevoBorrar, SWT.NONE);
		btnEnsenanzaBorrar.setToolTipText("Para borrar la enseñanza seleccionada (ésta debe estar vacía," +
				" o sea, no debe contener ningún título).");
		btnEnsenanzaBorrar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnEnsenanzaBorrar");
				Vector<Vector<String>> titulos=BBDD.consultarTitulo(listConIdEnsenanzas.idSeleccionado(), null);
				if (titulos!=null) if (titulos.size()>0) {
					String m="Soló podrá borrar una enseñanza cuando no contenga ningún título." +
							" Por favor borre los títulos de esta enseñanza antes de borrarla.";
					PCuaderno.MiPCuaderno.informacion(m);
				} else {
					BBDD.borrarEnsenanza(listConIdEnsenanzas.idSeleccionado());
					actualizarEnsenanzas(null);
				}
			}
		});
		btnEnsenanzaBorrar.setText("Borrar");
		
		txtEnsenanza = new Text(grpEnsenanzas, SWT.BORDER);
		txtEnsenanza.setToolTipText("Nombre largo de la enseñanza seleccionada. Por ejemplo: Bachillerato.");
		txtEnsenanza.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		TextoDemorado.add(txtEnsenanza,false,1024,null,null,true,listConIdEnsenanzas,null);
		
		Group grpNiveles = new Group(this, SWT.NONE);
		grpNiveles.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		grpNiveles.setText("Niveles del título:");
		GridLayout gl_grpNiveles = new GridLayout(2, false);
		gl_grpNiveles.horizontalSpacing = 2;
		gl_grpNiveles.marginHeight = 2;
		gl_grpNiveles.marginWidth = 2;
		gl_grpNiveles.verticalSpacing = 2;
		grpNiveles.setLayout(gl_grpNiveles);
		
		List listNiveles = new List(grpNiveles, SWT.BORDER | SWT.V_SCROLL);
		listNiveles.setToolTipText("Lista de los niveles tratados por el programa para ese título." +
				" Por ejemplo: 1, 2, 3, 4.");
		listNiveles.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listNiveles "+listConIdNiveles.idSeleccionado());
				actualizarDatosNivel();
			}
		});
		GridData gd_listNiveles = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 3);
		gd_listNiveles.widthHint = 50;
		gd_listNiveles.heightHint = 40;
		listNiveles.setLayoutData(gd_listNiveles);
		listConIdNiveles = new ListConId(listNiveles);
		
		Label lblNivelRef = new Label(grpNiveles, SWT.NONE);
		lblNivelRef.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblNivelRef.setText("Ref.:");
		
		txtNivelRef = new Text(grpNiveles, SWT.BORDER);
		txtNivelRef.setToolTipText("Nombre corto del nivel seleccionado. Por ejemplo: 3.");
		txtNivelRef.setText("XXX");
		GridData gd_txtNivel = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_txtNivel.widthHint = 40;
		txtNivelRef.setLayoutData(gd_txtNivel);
		TextoDemorado.add(txtNivelRef,false,3,null,null,false,listConIdNiveles,null);
		
		Composite compositeNivelNuevoBorrar = new Composite(grpNiveles, SWT.NONE);
		compositeNivelNuevoBorrar.setLayoutData(new GridData(SWT.LEFT, SWT.BOTTOM, false, false, 1, 1));
		GridLayout gl_compositeNivelNuevoBorrar = new GridLayout(1, false);
		gl_compositeNivelNuevoBorrar.verticalSpacing = 2;
		gl_compositeNivelNuevoBorrar.marginWidth = 2;
		gl_compositeNivelNuevoBorrar.marginHeight = 2;
		gl_compositeNivelNuevoBorrar.horizontalSpacing = 2;
		compositeNivelNuevoBorrar.setLayout(gl_compositeNivelNuevoBorrar);
		
		btnNivelNuevo = new Button(compositeNivelNuevoBorrar, SWT.NONE);
		btnNivelNuevo.setToolTipText("Para crear un nuevo nivel. Por ejemplo: 1, 2.");
		btnNivelNuevo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnNivelNuevo");
				String id = BBDD.insertarNivel(listConIdTitulos.idSeleccionado(),"999");
				actualizarNiveles(id);
				txtNivelRef.setFocus();
				txtNivelRef.selectAll();
			}
		});
		btnNivelNuevo.setText("Nuevo");
		
		btnNivelBorrar = new Button(compositeNivelNuevoBorrar, SWT.NONE);
		btnNivelBorrar.setToolTipText("Para borrar el nivel seleccionado (éste debe estar vacío, o sea," +
				" no debe contener ninguna clase ni ninguna materia).");
		btnNivelBorrar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnNivelBorrar");
				Vector<Vector<String>> clases=BBDD.consultarClase(listConIdNiveles.idSeleccionado(), null);
				Vector<Vector<String>> estudiantes=BBDD.consultarClase(listConIdNiveles.idSeleccionado(), null);
				if (clases!=null) if (clases.size()>0) {
					String m="Soló podrá borrar un Nivel cuando no contenga ninguna clase." +
							" Por favor borre las clases de este nivel antes de borrarlo.";
					PCuaderno.MiPCuaderno.informacion(m);
				} else if (estudiantes!=null) if (estudiantes.size()>0) {
					String m="Soló podrá borrar un Nivel cuando no contenga ningún estudiante." +
							" Por favor borre los estudiantes de este nivel antes de borrarlo.";
					PCuaderno.MiPCuaderno.informacion(m);
				} else {
					BBDD.borrarNivel(listConIdNiveles.idSeleccionado());
					actualizarNiveles(null);
				}
			}
		});
		btnNivelBorrar.setText("Borrar");
		
		Group grpClases = new Group(this, SWT.NONE);
		GridData gd_grpClases = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 2);
		gd_grpClases.heightHint = 125;
		grpClases.setLayoutData(gd_grpClases);
		grpClases.setText("Clases del nivel:");
		GridLayout gl_grpClases = new GridLayout(3, false);
		gl_grpClases.verticalSpacing = 2;
		gl_grpClases.marginWidth = 2;
		gl_grpClases.marginHeight = 2;
		gl_grpClases.horizontalSpacing = 2;
		grpClases.setLayout(gl_grpClases);
		
		List listClases = new List(grpClases, SWT.BORDER | SWT.V_SCROLL);
		listClases.setToolTipText("Lista de las clases tratadas por el programa para ese nivel. Por ejemplo: A, B, C.");
		listClases.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listClases "+listConIdClases.idSeleccionado());
				actualizarDatosClase();
				MateriaClase.fijarMateriaClase(listConIdMaterias.idSeleccionado(), listConIdClases.idSeleccionado());
				actualizarEstudiantes(null);
				actualizarMatriculados(null);
			}
		});
		GridData gd_listClases = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 3);
		gd_listClases.heightHint = 55;
		gd_listClases.widthHint = 60;
		listClases.setLayoutData(gd_listClases);
		listConIdClases = new ListConId(listClases);
		
		Label lblClaseRef = new Label(grpClases, SWT.NONE);
		lblClaseRef.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblClaseRef.setText("Ref.:");
		
		txtClaseRef = new Text(grpClases, SWT.BORDER);
		txtClaseRef.setToolTipText("Nombre de la clase seleccionada. Por ejemplo: D.");
		txtClaseRef.setText("XXXXX");
		GridData gd_txtClaseRef = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_txtClaseRef.widthHint = 55;
		txtClaseRef.setLayoutData(gd_txtClaseRef);
		TextoDemorado.add(txtClaseRef,false,5,null,null,false,listConIdClases,null);
		
		Composite compositeClaseNuevoBorrar = new Composite(grpClases, SWT.NONE);
		compositeClaseNuevoBorrar.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false, 2, 1));
		GridLayout gl_compositeClaseNuevoBorrar = new GridLayout(1, false);
		gl_compositeClaseNuevoBorrar.verticalSpacing = 2;
		gl_compositeClaseNuevoBorrar.marginWidth = 2;
		gl_compositeClaseNuevoBorrar.marginHeight = 2;
		gl_compositeClaseNuevoBorrar.horizontalSpacing = 2;
		compositeClaseNuevoBorrar.setLayout(gl_compositeClaseNuevoBorrar);
		
		btnClaseNueva = new Button(compositeClaseNuevoBorrar, SWT.NONE);
		btnClaseNueva.setToolTipText("Para crear una nueva clase. Por ejemplo: B, D.");
		btnClaseNueva.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnClaseNueva");
				String id = BBDD.insertarClase(listConIdNiveles.idSeleccionado(),"X");
				if (id==null || Integer.valueOf(id)<0) {
					String m="No se a podido añadir la clase. Probablemente sea por que no hay ningún profesor." +
							" Si es así añada primero un profesor.";
					PCuaderno.MiPCuaderno.error(m);
				} else {
					actualizarClases(id);
					txtClaseRef.setFocus();
					txtClaseRef.selectAll();
				}
			}
		});
		btnClaseNueva.setText("Nueva");
		
		btnClaseBorrar = new Button(compositeClaseNuevoBorrar, SWT.NONE);
		btnClaseBorrar.setToolTipText("Para borrar la clase seleccionada (ésta debe estar vacía, o sea," +
				" no debe contener ningun estudiante, y no referida en el horario).");
		btnClaseBorrar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnClaseBorrar");
				boolean vacia=true;
				Vector<Vector<String>> estudiantes=BBDD.consultarEstudiantesClase(listConIdClases.idSeleccionado(), null);
				if (estudiantes!=null) if (estudiantes.size()>0) {
					String m="Soló podrá borrar una clase cuando no contenga ningún estudiante." +
							" Por favor borre los estudiantes de esta clase antes de borrarla.";
					PCuaderno.MiPCuaderno.informacion(m);
					vacia=false;
				} 
				if (vacia) {
					String m="Se borrará la clase seleccionada, sus evaluaciones, su distribución" +
							" temporal para cada materia, los dias no lectivos especificos de esta" +
							" y se quitará del horario. ¿Desea borrarla?";
					int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
					if (buttonID == SWT.OK) {
						BBDD.borrarClase(listConIdClases.idSeleccionado());
						//actualizar horario
						actualizarClases(null);
						MateriaClase.fijarMateriaClase(listConIdMaterias.idSeleccionado(), listConIdClases.idSeleccionado());
						actualizarEstudiantes(null);
					}
				}
			}
		});
		btnClaseBorrar.setText("Borrar");
		
		Label lblClaseTutor = new Label(grpClases, SWT.NONE);
		lblClaseTutor.setLayoutData(new GridData(SWT.RIGHT, SWT.BOTTOM, false, false, 2, 1));
		lblClaseTutor.setText("Tutor:");
		
		Combo comboClaseTutor = new Combo(grpClases, SWT.NONE | SWT.READ_ONLY);
		comboClaseTutor.setToolTipText("Seleccione aqui el profesor tutor de la clase seleccionada.");
		GridData gd_combo = new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1);
		gd_combo.widthHint = 150;
		comboClaseTutor.setLayoutData(gd_combo);
		comboConIdClaseTutor = new ComboConId(comboClaseTutor);
		comboClaseTutor.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("comboClaseTutor");
				BBDD.modificarClaseTutor(listConIdClases.idSeleccionado(), comboConIdClaseTutor.idSeleccionado());
			}
		});
		
		Group grpMaterias = new Group(this, SWT.NONE);
		GridLayout gl_grpMaterias = new GridLayout(3, false);
		gl_grpMaterias.verticalSpacing = 2;
		gl_grpMaterias.marginWidth = 2;
		gl_grpMaterias.marginHeight = 2;
		gl_grpMaterias.horizontalSpacing = 2;
		grpMaterias.setLayout(gl_grpMaterias);
		GridData gd_grpMaterias = new GridData(SWT.FILL, SWT.FILL, true, false, 1, 2);
		gd_grpMaterias.heightHint = 125;
		grpMaterias.setLayoutData(gd_grpMaterias);
		grpMaterias.setText("Materias del nivel:");
		
		List listMaterias = new List(grpMaterias, SWT.BORDER | SWT.V_SCROLL);
		listMaterias.setToolTipText("Lista de las materias tratadas por el programa para ese nivel." +
				" Por ejemplo: Lenguaje,Informática.");
		listMaterias.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listMaterias "+listConIdMaterias.idSeleccionado());
				actualizarDatosMateria();
				MateriaClase.fijarMateriaClase(listConIdMaterias.idSeleccionado(), listConIdClases.idSeleccionado());
				actualizarMatriculados(null);
			}
		});
		GridData gd_listMaterias = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 2);
		gd_listMaterias.widthHint = 60;
		gd_listMaterias.heightHint = 55;
		listMaterias.setLayoutData(gd_listMaterias);
		listConIdMaterias = new ListConId(listMaterias);
		
		Label lblMateriaRef = new Label(grpMaterias, SWT.NONE);
		lblMateriaRef.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblMateriaRef.setText("Ref.:");
		
		txtMateriaRef = new Text(grpMaterias, SWT.BORDER);
		txtMateriaRef.setToolTipText("Referencia corta de la materia seleccionada. Por ejemplo: Len, Inf.");
		txtMateriaRef.setText("XXXXX");
		GridData gd_txtMateriaRef = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_txtMateriaRef.widthHint = 55;
		txtMateriaRef.setLayoutData(gd_txtMateriaRef);
		TextoDemorado.add(txtMateriaRef,false,5,null,null,false,listConIdMaterias,null);
		
		Composite compositeMateriaNuevoBorrar = new Composite(grpMaterias, SWT.NONE);
		compositeMateriaNuevoBorrar.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false, 2, 1));
		GridLayout gl_compositeMateriaNuevoBorrar = new GridLayout(1, false);
		gl_compositeMateriaNuevoBorrar.verticalSpacing = 2;
		gl_compositeMateriaNuevoBorrar.marginWidth = 2;
		gl_compositeMateriaNuevoBorrar.marginHeight = 2;
		gl_compositeMateriaNuevoBorrar.horizontalSpacing = 2;
		compositeMateriaNuevoBorrar.setLayout(gl_compositeMateriaNuevoBorrar);
		
		btnMateriaNueva = new Button(compositeMateriaNuevoBorrar, SWT.NONE);
		btnMateriaNueva.setToolTipText("Para crear una nueva materia. Por ejemplo: Lenguaje, Informática.");
		btnMateriaNueva.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnMateriaNueva");
				String id = BBDD.insertarMateria(listConIdNiveles.idSeleccionado(),"Nuevo","");
				actualizarMaterias(id);
				MateriaClase.fijarMateriaClase(listConIdMaterias.idSeleccionado(), listConIdClases.idSeleccionado());				
				actualizarDatosEstudiante();
				txtMateriaRef.setFocus();
				txtMateriaRef.selectAll();
			}
		});
		btnMateriaNueva.setText("Nueva");
		
		btnMateriaBorrar = new Button(compositeMateriaNuevoBorrar, SWT.NONE);
		btnMateriaBorrar.setToolTipText("Para borrar la clase seleccionada (ésta debe estar vacía, o sea," +
				" no debe contener ningun estudiante matriculado, y no referida en el horario).");
		btnMateriaBorrar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnMateriaBorrar");
				boolean vacia=true;
				Vector<Vector<String>> estudiantes=BBDD.consultarEstudiantesMateria(listConIdMaterias.idSeleccionado(), null);
				Vector<Vector<String>> tiposEvaluables=BBDD.consultarTiposEvaluablesParaMateria(listConIdMaterias.idSeleccionado());
				if (estudiantes!=null) if (estudiantes.size()>0) {
					String m="Soló podrá borrar una materia cuando no haya matriculado ningún estudiante" +
							" en ninguna de las clases. Por favor desmatricule los estudiantes" +
							" de todas las clases antes de borrarla.";
					PCuaderno.MiPCuaderno.informacion(m);
					vacia=false;
				} 
				if (tiposEvaluables!=null) if (tiposEvaluables.size()>0) {
					String m="Soló podrá borrar una materia cuando no haya definido ningún tipo de item" +
							" evaluable especificamente para esta materia. Por favor borre todos los tipos" +
							" de item evaluable especificos para esta materia antes de borrarla.";
					PCuaderno.MiPCuaderno.informacion(m);
					vacia=false;
				} 
				if (vacia) {
					String m="Se borrará la materia seleccionada, los parciales de esta y su" +
							" programación. ¿Desea borrarla?";
					int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
					if (buttonID == SWT.OK) {
						BBDD.borrarMateria(listConIdMaterias.idSeleccionado());
						//actualizar horario
						actualizarMaterias(null);
						MateriaClase.fijarMateriaClase(listConIdMaterias.idSeleccionado(), listConIdClases.idSeleccionado());
						actualizarEstudiantes(null);
					}
				}
			}
		});
		btnMateriaBorrar.setText("Borrar");
		
		txtMateria = new Text(grpMaterias, SWT.BORDER);
		txtMateria.setToolTipText("Nombre largo de la materia seleccionada. Por ejemplo: Lenguaje, Informática.");
		txtMateria.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1));
		TextoDemorado.add(txtMateria,false,256,null,null,true,listConIdMaterias,null);
				
		btnImportarEstudiantes = new Button(this, SWT.NONE);
		btnImportarEstudiantes.setToolTipText("Importar estudiantes para la clase desde un archivo 'CSV'.");
		btnImportarEstudiantes.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		btnImportarEstudiantes.setText("Importar");
		btnImportarEstudiantes.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnImportarEstudiantes");
				String m="Se importar los datos nombre y apellidos de estudiantes para la clase seleccionada " +
					"desde un archivo.El formato de cada línea de texto debe ser:\nApellidos,Nombre\n" +
					"El programa quitará del archivo los caractéres comillas dobles (\") y simpbles (')\n" +
					"¿Desea continuar?";
				int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
				if (buttonID == SWT.OK) {
					m="La primera linea puede contener una cabecera (Ej.'Estudiante') o directamente los " +
						"apellidos y el nombre del primer estudiante.\n\nPulse aceptar o ok para descartar " +
						"la primera linea o, pulse cancelar o cancel para utilizar la primera línea para el " +
						"primer estudiante.";
					buttonID = PCuaderno.MiPCuaderno.pregunta(m);
			        FileDialog fd = new FileDialog(PCuaderno.MiPCuaderno.shellPrincipal, SWT.OPEN);
			        fd.setText("Importar estudiantes desde");
			        fd.setFilterPath(BBDD.dirBBDD);
			        String[] filterExt = { "*.csv","*.txt","*.*" };
			        fd.setFilterExtensions(filterExt);
			        String nomArchivo = fd.open();
					BBDD.importarEstudiantes(nomArchivo,MateriaClase.getIdClaseDeTrabajo(),(buttonID == SWT.OK));
					actualizarEstudiantes(null);
					listConIdEstudiantes.deSeleccionarTodo();
					listConIdEstudiantes.seleccionarUltimo();
				}
			}
		});
		
		Group grpTitulos = new Group(this, SWT.NONE);
		GridData gd_grpTitulos = new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1);
		gd_grpTitulos.heightHint = 150;
		grpTitulos.setLayoutData(gd_grpTitulos);
		grpTitulos.setText("Titulos de enseñanza:");
		GridLayout gl_grpTitulos = new GridLayout(2, false);
		gl_grpTitulos.verticalSpacing = 2;
		gl_grpTitulos.marginWidth = 2;
		gl_grpTitulos.marginHeight = 2;
		gl_grpTitulos.horizontalSpacing = 2;
		grpTitulos.setLayout(gl_grpTitulos);
		
		List listTitulos = new List(grpTitulos, SWT.BORDER | SWT.V_SCROLL);
		listTitulos.setToolTipText("Lista de los títulos tratados por el programa para esa enseñanza. Por ejemplo:" +
				" ESO, Bachillerato Tecnológico, CFGM de Sistemas Microinformáticos en Red.");
		GridData gd_listTitulos = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 3);
		gd_listTitulos.heightHint = 55;
		gd_listTitulos.widthHint = 60;
		listTitulos.setLayoutData(gd_listTitulos);
		listTitulos.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listTitulos "+listConIdTitulos.idSeleccionado());
				actualizarDatosTitulo();
			}
		});
		listConIdTitulos = new ListConId(listTitulos);
		
		Label lblTituloRef = new Label(grpTitulos, SWT.NONE);
		lblTituloRef.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblTituloRef.setText("Ref.:");
		
		txtTituloRef = new Text(grpTitulos, SWT.BORDER);
		txtTituloRef.setToolTipText("Referencia corta del título seleccionado. Por ejemplo: BchTe.");
		txtTituloRef.setText("XXXXX");
		GridData gd_textTituloRef = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_textTituloRef.widthHint = 55;
		txtTituloRef.setLayoutData(gd_textTituloRef);
		TextoDemorado.add(txtTituloRef,false,5,null,null,false,listConIdTitulos,null);
		
		Composite compositeTituloNuevoBorrar = new Composite(grpTitulos, SWT.NONE);
		compositeTituloNuevoBorrar.setLayoutData(new GridData(SWT.LEFT, SWT.BOTTOM, false, false, 1, 1));
		GridLayout gl_compositeTituloNuevoBorrar = new GridLayout(1, false);
		gl_compositeTituloNuevoBorrar.verticalSpacing = 2;
		gl_compositeTituloNuevoBorrar.marginWidth = 2;
		gl_compositeTituloNuevoBorrar.marginHeight = 2;
		gl_compositeTituloNuevoBorrar.horizontalSpacing = 2;
		compositeTituloNuevoBorrar.setLayout(gl_compositeTituloNuevoBorrar);
		
		btnTituloNuevo = new Button(compositeTituloNuevoBorrar, SWT.NONE);
		btnTituloNuevo.setToolTipText("Para crear un nuevo título. Por ejemplo: CFGS de Administración" +
				" de Sistemas Informáticos y Redes, ESO.");
		btnTituloNuevo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnTituloNuevo");
				String id = BBDD.insertarTitulo(listConIdEnsenanzas.idSeleccionado(),"Nuevo", "");
				actualizarTitulos(id);
				txtTituloRef.setFocus();
				txtTituloRef.selectAll();
			}
		});
		btnTituloNuevo.setText("Nuevo");
		
		btnTituloBorrar = new Button(compositeTituloNuevoBorrar, SWT.NONE);
		btnTituloBorrar.setToolTipText("Para borrar el título seleccionado (éste debe estar vacío, o sea," +
				" no debe contener ningún nivel).");
		btnTituloBorrar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnTituloBorrar");
					Vector<Vector<String>> niveles=BBDD.consultarNivel(listConIdTitulos.idSeleccionado(), null);
					if (niveles!=null) if (niveles.size()>0) {
						String m="Soló podrá borrar un título cuando no contenga ningún nivel. " +
								"Por favor borre los niveles de este título antes de borrarlo.";
						PCuaderno.MiPCuaderno.informacion(m);
					} else {
						BBDD.borrarTitulo(listConIdTitulos.idSeleccionado());
						actualizarTitulos(null);
					}
				}
			});
		btnTituloBorrar.setText("Borrar");
		
		txtTitulo = new Text(grpTitulos, SWT.BORDER);
		txtTitulo.setToolTipText("Nombre largo del título seleccionado. Por ejemplo: Bachillerato Tecnológico.");
		txtTitulo.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		TextoDemorado.add(txtTitulo,false,1024,null,null,true,listConIdTitulos, null);
		
		grpEstudiantes = new Group(this, SWT.NONE);
		GridLayout gl_grpEstudiantes = new GridLayout(4, false);
		gl_grpEstudiantes.verticalSpacing = 2;
		gl_grpEstudiantes.marginWidth = 2;
		gl_grpEstudiantes.marginHeight = 2;
		gl_grpEstudiantes.horizontalSpacing = 2;
		grpEstudiantes.setLayout(gl_grpEstudiantes);
		GridData gd_grpEstudiantes = new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1);
		gd_grpEstudiantes.heightHint = 150;
		grpEstudiantes.setLayoutData(gd_grpEstudiantes);
		grpEstudiantes.setText(TituloEstudiantes);
		
		List listEstudiantes = new List(grpEstudiantes, SWT.BORDER | SWT.V_SCROLL | SWT.MULTI);
		listEstudiantes.setToolTipText("Lista de los estudiantes tratados por el programa para esa clase.");
		GridData gd_listEstudiantes = new GridData(SWT.FILL, SWT.FILL, true, true, 3, 1);
		gd_listEstudiantes.heightHint = 30;
		gd_listEstudiantes.widthHint = 150;
		listEstudiantes.setLayoutData(gd_listEstudiantes);
		listConIdEstudiantes = new ListConId(listEstudiantes);
		listEstudiantes.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listEstudiantes "+((listConIdEstudiantes.idSeleccionados().size()>1)?"varios":listConIdEstudiantes.idSeleccionado()));
				actualizarDatosEstudiante();
			}
		});
		
		Composite compositeEstudianteNuevoBorrar = new Composite(grpEstudiantes, SWT.NONE);
		compositeEstudianteNuevoBorrar.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false, 1, 1));
		GridLayout gl_compositeEstudianteNuevoBorrar = new GridLayout(1, false);
		gl_compositeEstudianteNuevoBorrar.verticalSpacing = 2;
		gl_compositeEstudianteNuevoBorrar.marginWidth = 2;
		gl_compositeEstudianteNuevoBorrar.marginHeight = 2;
		gl_compositeEstudianteNuevoBorrar.horizontalSpacing = 2;
		compositeEstudianteNuevoBorrar.setLayout(gl_compositeEstudianteNuevoBorrar);
		
		btnEstudianteNuevo = new Button(compositeEstudianteNuevoBorrar, SWT.NONE);
		btnEstudianteNuevo.setToolTipText("Para crear un nuevo estudiante.");
		btnEstudianteNuevo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		btnEstudianteNuevo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnEstudianteNuevo");
				String id = BBDD.insertarEstudiante(MateriaClase.getIdClaseDeTrabajo(),"Nombre","Apellidos");
				listConIdEstudiantes.deSeleccionarTodo();
				actualizarEstudiantes(id);
				txtEstudianteNombre.setFocus();
				txtEstudianteNombre.selectAll();
			}
		});
		btnEstudianteNuevo.setText("Nuevo");
		
		btnEstudianteBorrar = new Button(compositeEstudianteNuevoBorrar, SWT.NONE);
		btnEstudianteBorrar.setToolTipText("Para borrar el estudiante o estudiantes seleccionados.");
		btnEstudianteBorrar.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		btnEstudianteBorrar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnEstudianteBorrar "+listConIdEstudiantes.idSeleccionados().size()+" seleccionados.");
				String m=null;
				if (listConIdEstudiantes.idSeleccionados().size()>1){
					m="Se va a borrar "+listConIdEstudiantes.idSeleccionados().size()+" estudiantes seleccionados, todas sus evaluaciones y" +
							" cita con tutores. ¿Desea borrarlos?";
				} else {
					m="Se va a borrar el estudiante seleccionado, todas sus evaluaciones y" +
							" cita con tutores. ¿Desea borrarlo?";
				}
				int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
				if (buttonID == SWT.OK) {
					Vector<String> seleccionados = listConIdEstudiantes.idSeleccionados();
					for (int i=0;i<seleccionados.size();i++) 
						BBDD.borrarEstudiante(seleccionados.get(i));
					actualizarEstudiantes(null);
					actualizarMatriculados(null);
				}
			}
		});
		btnEstudianteBorrar.setText("Borrar");
		
		btnEstudianteMatricular = new Button(compositeEstudianteNuevoBorrar, SWT.NONE);
		btnEstudianteMatricular.setToolTipText("Para matricular el estudiante o los estudiantes" +
				" seleccionados en la materia seleccionada.");
		btnEstudianteMatricular.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		btnEstudianteMatricular.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnEstudianteMatricular");
				BBDD.insertarEstudiantesMateriaClase(MateriaClase.getIdMateriaClaseDeTrabajo(),
						listConIdEstudiantes.idSeleccionados());
				actualizarMatriculados(null);
			}
		});
		btnEstudianteMatricular.setText("Matricular");
		
		txtEstudianteNombre = new Text(grpEstudiantes, SWT.BORDER);
		txtEstudianteNombre.setToolTipText("Nombre del estudiante seleccioinado.");
		txtEstudianteNombre.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		TextoDemorado.add(txtEstudianteNombre,false,256,null,null,false,listConIdEstudiantes,null);
		
		Label labelEstudianteComa = new Label(grpEstudiantes, SWT.NONE);
		labelEstudianteComa.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		labelEstudianteComa.setText(",");
		
		txtEstudianteApellidos = new Text(grpEstudiantes, SWT.BORDER);
		txtEstudianteApellidos.setToolTipText("Apellidos del estudiante seleccionado.");
		txtEstudianteApellidos.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		TextoDemorado.add(txtEstudianteApellidos,false,256,null,null,true,listConIdEstudiantes,null);
		
		composite = new Composite(grpEstudiantes, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 4, 1));
		GridLayout gl_composite = new GridLayout(2, false);
		gl_composite.verticalSpacing = 2;
		gl_composite.marginWidth = 2;
		gl_composite.marginHeight = 2;
		gl_composite.horizontalSpacing = 2;
		composite.setLayout(gl_composite);
		
		Label lblEstudianteDatos = new Label(composite, SWT.NONE);
		lblEstudianteDatos.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblEstudianteDatos.setText("Datos:");
		
		txtEstudianteDatos = new Text(composite, SWT.BORDER);
		txtEstudianteDatos.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		txtEstudianteDatos.setToolTipText("Información del estudiante seleccionado.");
		TextoDemorado.add(txtEstudianteDatos,false,1024,null,null,true,listConIdEstudiantes,null);
		
		grpMatriculados = new Group(this, SWT.NONE);
		GridData gd_grpMatriculados = new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1);
		gd_grpMatriculados.heightHint = 150;
		grpMatriculados.setLayoutData(gd_grpMatriculados);
		grpMatriculados.setText(TituloMatriculados);
		GridLayout gl_grpMatriculados = new GridLayout(1, false);
		gl_grpMatriculados.verticalSpacing = 2;
		gl_grpMatriculados.marginWidth = 2;
		gl_grpMatriculados.marginHeight = 2;
		gl_grpMatriculados.horizontalSpacing = 2;
		grpMatriculados.setLayout(gl_grpMatriculados);
		
		List listMatriculados = new List(grpMatriculados, SWT.BORDER | SWT.V_SCROLL | SWT.MULTI);
		listMatriculados.setToolTipText("Estudiantes de la clase matriculados en esa materia.");
		GridData gd_listMatriculados = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_listMatriculados.heightHint = 55;
		listMatriculados.setLayoutData(gd_listMatriculados);
		listConIdMatriculados = new ListConId(listMatriculados);
		
		btnMatriculadoQuitar = new Button(grpMatriculados, SWT.NONE);
		btnMatriculadoQuitar.setToolTipText("Desmatricular el estudiante o los estudiantes" +
				" seleccionados solo de la materia seleccionada. Con lo que se borrarán las" +
				" evaluaciones que hubiera de ese estudiante/s en esa matricula.");
		btnMatriculadoQuitar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnMatriculadoQuitar");
				BBDD.borrarEstudiantesMateriaClase(MateriaClase.getIdMateriaClaseDeTrabajo(),listConIdMatriculados.idSeleccionados());
				actualizarMatriculados(null);
			}
		});
		btnMatriculadoQuitar.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		btnMatriculadoQuitar.setText("DesMatricular");
	}
	public void actualizarEnsenanzas(String idEnsenanza){
		listConIdEnsenanzas.rellenarEnsenanzas();
		listConIdEnsenanzas.seleccionarId((idEnsenanza!=null)?idEnsenanza:MateriaClase.getIdEnsenanzaDeTrabajo());
		actualizarDatosEnsenanza();
	}
	public void actualizarDatosEnsenanza(){
		if (listConIdEnsenanzas.idSeleccionado()==null){
			txtEnsenanzaRef.setEnabled(false);txtEnsenanzaRef.setText("");
			txtEnsenanza.setEnabled(false);txtEnsenanza.setText("");
			btnEnsenanzaBorrar.setEnabled(false);
		} else {
			Vector<Vector<String>> ensenanza=BBDD.consultarEnsenanza(listConIdEnsenanzas.idSeleccionado());
			TextoDemorado.modificaSinActualizar(txtEnsenanzaRef,ensenanza.get(0).get(1));
			TextoDemorado.modificaSinActualizar(txtEnsenanza,ensenanza.get(0).get(2));
			btnEnsenanzaBorrar.setEnabled(true);
		}
		actualizarTitulos(null);
	}
	public void actualizarTitulos(String idTitulo){
		listConIdTitulos.rellenarTitulos(listConIdEnsenanzas.idSeleccionado());
		listConIdTitulos.seleccionarId((idTitulo!=null)?idTitulo:MateriaClase.getIdTituloDeTrabajo());
		actualizarDatosTitulo();
	}
	public void actualizarDatosTitulo(){
		if (listConIdTitulos.idSeleccionado()==null){
			txtTituloRef.setEnabled(false);txtTituloRef.setText("");
			txtTitulo.setEnabled(false);txtTitulo.setText("");
			btnTituloBorrar.setEnabled(false);
		} else {
			Vector<Vector<String>> titulo=BBDD.consultarTitulo(listConIdEnsenanzas.idSeleccionado(),listConIdTitulos.idSeleccionado());
			TextoDemorado.modificaSinActualizar(txtTituloRef,titulo.get(0).get(2));
			TextoDemorado.modificaSinActualizar(txtTitulo,titulo.get(0).get(3));
			btnTituloBorrar.setEnabled(true);
		}
		if (listConIdEnsenanzas.idSeleccionado()==null) btnTituloNuevo.setEnabled(false);
		else btnTituloNuevo.setEnabled(true);
		actualizarNiveles(null);
	}
	public void actualizarNiveles(String idNivel){
		listConIdNiveles.rellenarNiveles(listConIdTitulos.idSeleccionado());
		listConIdNiveles.seleccionarId((idNivel!=null)?idNivel:MateriaClase.getIdNivelDeTrabajo());
		actualizarDatosNivel();
	}
	public void actualizarDatosNivel(){
		if (listConIdNiveles.idSeleccionado()==null){
			txtNivelRef.setEnabled(false);txtNivelRef.setText("");
			btnNivelBorrar.setEnabled(false);
		} else {
			Vector<Vector<String>> nivel=BBDD.consultarNivel(listConIdTitulos.idSeleccionado(),listConIdNiveles.idSeleccionado());
			TextoDemorado.modificaSinActualizar(txtNivelRef,nivel.get(0).get(2));
			btnNivelBorrar.setEnabled(true);
		}
		if (listConIdTitulos.idSeleccionado()==null) btnNivelNuevo.setEnabled(false);
		else btnNivelNuevo.setEnabled(true);
		actualizarClases(null);
		actualizarMaterias(null);
		MateriaClase.fijarMateriaClase(listConIdMaterias.idSeleccionado(), listConIdClases.idSeleccionado());
		actualizarEstudiantes(null);
		actualizarMatriculados(null);
	}
	public void actualizarClases(String idClase){
		listConIdClases.rellenarClases(listConIdNiveles.idSeleccionado());
		listConIdClases.seleccionarId((idClase!=null)?idClase:MateriaClase.getIdClaseDeTrabajo());
		actualizarDatosClase();
	}
	public void actualizarDatosClase(){
		if (listConIdClases.idSeleccionado()==null){
			txtClaseRef.setEnabled(false);txtClaseRef.setText("");
			comboConIdClaseTutor.borrar();
			btnClaseBorrar.setEnabled(false);
		} else {
			Vector<Vector<String>> clase=BBDD.consultarClase(listConIdNiveles.idSeleccionado(),listConIdClases.idSeleccionado());
			TextoDemorado.modificaSinActualizar(txtClaseRef,clase.get(0).get(2));
			comboConIdClaseTutor.rellenarProfesores();
			comboConIdClaseTutor.seleccionarId(clase.get(0).get(4));
			btnClaseBorrar.setEnabled(true);
		}
		if (listConIdNiveles.idSeleccionado()==null) btnClaseNueva.setEnabled(false);
		else btnClaseNueva.setEnabled(true);
	}
	public void actualizarMaterias(String idMateria){
		listConIdMaterias.rellenarMaterias(listConIdNiveles.idSeleccionado());
		listConIdMaterias.seleccionarId((idMateria!=null)?idMateria:MateriaClase.getIdMateriaDeTrabajo());
		actualizarDatosMateria();
	}
	public void actualizarDatosMateria(){
		if (listConIdMaterias.idSeleccionado()==null){
			txtMateriaRef.setEnabled(false);txtMateriaRef.setText("");
			txtMateria.setEnabled(false);txtMateria.setText("");
			btnMateriaBorrar.setEnabled(false);
		} else {
			Vector<Vector<String>> clase=BBDD.consultarMateria(listConIdNiveles.idSeleccionado(),listConIdMaterias.idSeleccionado());
			TextoDemorado.modificaSinActualizar(txtMateriaRef,clase.get(0).get(1));
			TextoDemorado.modificaSinActualizar(txtMateria,clase.get(0).get(2));
			btnMateriaBorrar.setEnabled(true);
		}
		if (listConIdNiveles.idSeleccionado()==null) btnMateriaNueva.setEnabled(false);
		else btnMateriaNueva.setEnabled(true);
	}
	public void actualizarEstudiantes(String idEstudiante){
		listConIdEstudiantes.rellenarEstudiantes(listConIdClases.idSeleccionado());
		grpEstudiantes.setText(TituloEstudiantes+" "+listConIdEstudiantes.numeroElementos());
		listConIdEstudiantes.seleccionarId(idEstudiante);
		actualizarDatosEstudiante();
	}
	public void actualizarDatosEstudiante(){
		if (listConIdEstudiantes.idSeleccionado()==null){
			txtEstudianteNombre.setEnabled(false);txtEstudianteNombre.setText("");
			txtEstudianteApellidos.setEnabled(false);txtEstudianteApellidos.setText("");
			txtEstudianteDatos.setEnabled(false);txtEstudianteDatos.setText("");
			btnEstudianteBorrar.setEnabled(false);
			btnEstudianteMatricular.setEnabled(false);
		} else {
			if (listConIdEstudiantes.idSeleccionados().size()>1){
				txtEstudianteNombre.setEnabled(false);txtEstudianteNombre.setText("");
				txtEstudianteApellidos.setEnabled(false);txtEstudianteApellidos.setText("");
				txtEstudianteDatos.setEnabled(false);txtEstudianteDatos.setText("");
			} else {
				Vector<Vector<String>> clase=BBDD.consultarEstudiantesClase(listConIdClases.idSeleccionado(),listConIdEstudiantes.idSeleccionado());
				TextoDemorado.modificaSinActualizar(txtEstudianteNombre,clase.get(0).get(2));
				TextoDemorado.modificaSinActualizar(txtEstudianteApellidos,clase.get(0).get(1));
				TextoDemorado.modificaSinActualizar(txtEstudianteDatos,((clase.get(0).get(3)!=null)?clase.get(0).get(3):""));
			}
			btnEstudianteBorrar.setEnabled(true);
			if (listConIdMaterias.idSeleccionado()!=null)
				btnEstudianteMatricular.setEnabled(true);
			else
				btnEstudianteMatricular.setEnabled(false);
		}
		if (listConIdClases.idSeleccionado()==null) {
			btnEstudianteNuevo.setEnabled(false);
			btnImportarEstudiantes.setEnabled(false);
		} else {
			btnEstudianteNuevo.setEnabled(true);
			btnImportarEstudiantes.setEnabled(true);
		}
	}
	public void actualizarMatriculados(String idEstudiante){
		listConIdMatriculados.rellenarMatriculados(listConIdMaterias.idSeleccionado(),listConIdClases.idSeleccionado());
		grpMatriculados.setText(TituloMatriculados+" "+listConIdMatriculados.numeroElementos());
		listConIdMatriculados.seleccionarId(idEstudiante);
		actualizarDatosMatriculado();
	}
	public void actualizarDatosMatriculado(){
		if (listConIdMatriculados.numeroElementos()==0){
			btnMatriculadoQuitar.setEnabled(false);
		} else {
			btnMatriculadoQuitar.setEnabled(true);
		}
	}
}
